"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handler = exports.help = exports.commandNames = exports.cliOptionsTypes = exports.rcOptionsTypes = void 0;
const config_1 = require("@pnpm/config");
const pick_js_1 = __importDefault(require("ramda/src/pick.js"));
const render_help_1 = __importDefault(require("render-help"));
const run_1 = require("./run");
function rcOptionsTypes() {
    return {
        ...(0, pick_js_1.default)([
            'npm-path',
        ], config_1.types),
    };
}
exports.rcOptionsTypes = rcOptionsTypes;
function cliOptionsTypes() {
    return run_1.IF_PRESENT_OPTION;
}
exports.cliOptionsTypes = cliOptionsTypes;
exports.commandNames = ['restart'];
function help() {
    return (0, render_help_1.default)({
        description: 'Restarts a package. Runs a package\'s "stop", "restart", and "start" scripts, and associated pre- and post- scripts.',
        descriptionLists: [
            {
                title: 'Options',
                list: [
                    run_1.IF_PRESENT_OPTION_HELP,
                ],
            },
        ],
        usages: ['pnpm restart [-- <args>...]'],
    });
}
exports.help = help;
async function handler(opts, params) {
    await (0, run_1.handler)(opts, ['stop', ...params]);
    await (0, run_1.handler)(opts, ['restart', ...params]);
    await (0, run_1.handler)(opts, ['start', ...params]);
}
exports.handler = handler;
//# sourceMappingURL=restart.js.map