import { CompletionFunc } from '@pnpm/command';
import { Config } from '@pnpm/config';
import { RecursiveRunOpts } from './runRecursive';
export declare const IF_PRESENT_OPTION: {
    'if-present': BooleanConstructor;
};
export declare const IF_PRESENT_OPTION_HELP: {
    description: string;
    name: string;
};
export declare const PARALLEL_OPTION_HELP: {
    description: string;
    name: string;
};
export declare const shorthands: {
    parallel: string[];
};
export declare function rcOptionsTypes(): {};
export declare function cliOptionsTypes(): {
    recursive: BooleanConstructor;
    reverse: BooleanConstructor;
    'if-present': BooleanConstructor;
};
export declare const completion: CompletionFunc;
export declare const commandNames: string[];
export declare function help(): string;
export declare type RunOpts = Omit<RecursiveRunOpts, 'allProjects' | 'selectedProjectsGraph' | 'workspaceDir'> & {
    recursive?: boolean;
} & Pick<Config, 'dir' | 'engineStrict' | 'extraBinPaths' | 'reporter' | 'scriptsPrependNodePath' | 'scriptShell' | 'shellEmulator' | 'enablePrePostScripts' | 'userAgent'> & ({
    recursive?: false;
} & Partial<Pick<Config, 'allProjects' | 'selectedProjectsGraph' | 'workspaceDir'>> | {
    recursive: true;
} & Required<Pick<Config, 'allProjects' | 'selectedProjectsGraph' | 'workspaceDir'>>) & {
    argv?: {
        original: string[];
    };
    fallbackCommandUsed?: boolean;
};
export declare function handler(opts: RunOpts, params: string[]): Promise<string | void | {
    exitCode: number;
}>;
